<?php

/**
 * 
 *
 * @version $Id: php.xml,v 1.0 2003-01-02 20:23:56+01 administrateur Exp administrateur $
 **/

class irc_control
{
var $socket; //le socket
var $usercommand; //le champ gtkentry ac la commande de l'utilisateur
var $fp; //la ressource de fichier pour le log
var $currentmsg; //sert  recomposer des messages briss si msg socket trop long. efficacit non prouve
var $notebook; //le notebook ac les diffrents chans
var $channels = array(); //cle : nom du canal, val : objet channel = onglet du notebook
var $nick; //le nick de l'utilisateur
var $currentchannel; //ultra utile : maj quand on change de page
var $debugmode;
var $debugconsole;
var $debugentry;
var $timeouts = array();
var $window; //fentre principale
var $pvs = array(); //pareil que pour chans sauf que c pour les pvs
var $couleurs = array(); //les couleurs standard
var $performbuffer;
	
	function irc_control($serveur, $port, $nick, $performbuffer = null)
	{
		$this->performbuffer = $performbuffer;
		$this->nick = strtolower($nick);
	
		$this->couleurs['server'] = gdk::color_parse('#008040');
		$this->couleurs['default'] = gdk::color_parse('#004080');
		$this->couleurs['useraction'] = gdk::color_parse('#FF40FF');
		$this->couleurs['info'] = gdk::color_parse('#408080');
		$this->couleurs['op'] = gdk::color_parse('#FF0066');
		$this->couleurs['halfop'] = gdk::color_parse('#00CC99');
		$this->couleurs['voice'] = gdk::color_parse('#99CCFF');
		$this->couleurs['user'] = gdk::color_parse('#000000');
		
		$this->couleurs['irc'][0] = gdk::color_parse('#FFFFFF');
		$this->couleurs['irc'][1] = gdk::color_parse('#000000');
		$this->couleurs['irc'][2] = gdk::color_parse('#000080');
		$this->couleurs['irc'][3] = gdk::color_parse('#008000');
		$this->couleurs['irc'][4] = gdk::color_parse('#FF0000');
		$this->couleurs['irc'][5] = gdk::color_parse('#008040');
		$this->couleurs['irc'][6] = gdk::color_parse('#800080');
		$this->couleurs['irc'][7] = gdk::color_parse('#FF8040');
		$this->couleurs['irc'][8] = gdk::color_parse('#FFFF00');
		$this->couleurs['irc'][9] = gdk::color_parse('#00FF00');
		$this->couleurs['irc'][10] = gdk::color_parse('#008080');
		$this->couleurs['irc'][11] = gdk::color_parse('#00FFFF');
		$this->couleurs['irc'][12] = gdk::color_parse('#0000FF');
		$this->couleurs['irc'][13] = gdk::color_parse('#FF00FF');
		$this->couleurs['irc'][14] = gdk::color_parse('#808080');
		$this->couleurs['irc'][15] = gdk::color_parse('#C0C0C0');
	
		$this->font = gdk::font_load('-adobe-helvetica-medium-r-normal--*-120-*-*-*-*-*-*,*');
		$this->fontnormal = gdk::font_load('-unknown-Arial-normal-r-normal--*-110-96-96-p-0-iso8859-1');
		$this->fontbold = gdk::font_load('-unknown-Arial-bold-r-normal--*-110-96-96-p-0-iso8859-1');
		
		$this->window = &new GtkWindow;
		$this->window->set_usize('640', '480');
		$this->window->set_title("Fentre IRC");
		$this->window->realize();
		$this->window->connect("destroy", "killwindow", &$this);
		
		$gbox = &new GtkVBox(false, 10);
		$gbox->set_border_width(10);
		$this->window->add($gbox);
		
		$this->notebook = &new GtkNotebook;
		$this->notebook->set_tab_pos(GTK_POS_TOP);
		$gbox->pack_start($this->notebook, true, true, 0);
		$this->notebook->realize();
		$this->new_notebook_page('status');
		
		$this->usercommand = &new GtkEntry();
		$gbox->pack_start($this->usercommand, false, false);
		
		$this->window->show_all();
		
		$this->irc_connect($serveur, $port);
		
		$this->notebook->connect('switch_page', array(&$this, "page_switch"));
		$this->usercommand->connect_after("activate", array(&$this, "parse_user_msg"));
		
		$this->fp = fopen('log.txt', 'a+');
		fputs($this->fp, "\r\n\r\n");
		
		if (!file_exists("../irc_chatter/debug.lock")) {
			$debugwindow = &new GtkWindow;
			$debugwindow->set_usize('400', '300');
			$debugwindow->set_title("Debug");
			$debugwindow->connect("destroy", "destroy_window", &$this);
			
			$dgbox = &new GtkVBox(false, 10);
			$dgbox->set_border_width(10);
			$debugwindow->add($dgbox);
			
			$dhbox = &new GtkHBox;
			$this->debugconsole = &new GtkText;
			$dscrollbar = &new GtkVScrollbar($this->debugconsole->vadj);
			$this->debugconsole -> set_editable(false);
			$this->debugconsole -> set_word_wrap(true);
			$dhbox->pack_start($this->debugconsole, true, true, 5);
			$dhbox->pack_end($dscrollbar, false);
			$dgbox->pack_start($dhbox);
			
			$this->debugentry = &new GtkEntry();
			$dgbox->pack_start($this->debugentry, false, false);
			
			$debugwindow->show_all();
			
			$this->debugentry->connect_after("activate", array(&$this, "parse_debug_command"));
		}
		
		$this->timeouts[0] = gtk::timeout_add('20', array(&$this, "update_irc"));
		$this->timeouts[1] = gtk::timeout_add('2', array(&$this, "refresh"));
		
	}

	function parse_debug_command($widget)
	{
		$command = $this->debugentry->get_chars(0, -1);
		$this->parse_server_msg($command);
	}
	
	function display($text, $type=null, $channel="status")
	{
		$channel = strtolower($channel);
		if (!$this->channels[$channel])
		{
		    $channel = "status";
		}
		switch($type){
				case 'server' : 
					$fg1 = $this->couleurs['server'];
					break;
				case 'user' : 
					$fg1 = $this->couleurs['user'];
					break;
				case 'useraction' : 
					$fg1 = $this->couleurs['useraction'];
					break;
				case 'info' : 
					$fg1 = $this->couleurs['info'];
					break;
				default:
					$fg1 = null;
		} // switch
		
		/* *explications sur ce bloc
		* on parcourt la chane et on examine chaque caractre
		* si c un caractre qui dit de mettre en gras
		* on insre le texte collect auparavant 
		* on met gras true au dpart
		* parce que la premier \x02 rencontr
		* va demander  insrer le texte mis avant
		* donc on passe gras en faux et aprs on insre le texte
		* d'o la ncessit de mettre gras = true au dbut
		* un peu de lagg si bcp de couleurs
		* mais mthode efficace
		* le gras  la fin c pour vrifier qu'on affiche bien tout le texte
		* et la fin dans la bonne weight
		* */
		$gras = false;
		$font = $this->fontnormal;
		$k = 0;
		$inserttext;
		$insertfg = $fg1;
		$insertbg = null;
		$fg = $fg1;
		$bg = null;
		$afficher = false;
		$text = $text."\x02";
		while($k <= strlen($text))
		{
			$lettre = $text[$k];
			switch($lettre){
				case "\x02": 
					switch($gras){
						case false : 
							$gras = true;
							$nextfont = $this->fontbold;
							break;
						case true : 
							$gras = false;
							$nextfont = $this->fontnormal;
							break;
					} // switch
					$afficher = true;
					break;
				case "\x03": 
					if (preg_match("/\03([0123456789]{1,2})((,([0123456789]{1,2}))|)/", substr($text, $k, 6), $couleurs)) {
					 
						$fg = $couleurs[1] ? $this->couleurs['irc'][$couleurs[1]] : $fg1;
						$bg = $couleurs[4] ? $this->couleurs['irc'][$couleurs[4]] : null;
						
						$codelen = strlen($couleurs[0]) - 1;
						/*$text[$k+1] = null;
						if (strlen($fg) == 2)
							$text[$k+2] = null;
						if ($couleurs[4])
							$text[$k+3] = null;
						if ($couleurs[4])
							$text[$k+4] = null;
						if (strlen($couleurs[4]) == 2)
							$text[$k+5] = null;*/
					}
					$afficher = true;
					break;
				default:
					if ($codelen > 0) {
					    $codelen--;
					}
					else
					{
						$inserttext .= $lettre;
					}
			} // switch
			
			if ($afficher) {	
				$this->channels[$channel]->console->insert($font, $insertfg, $insertbg, $inserttext);
				$inserttext = null;
				$afficher = false;
				$font = $nextfont;
				$insertfg = $fg;
				$insertbg = $bg;
			}
			
			$k++;
		}
		$this->channels[$channel]->pixwid->set($this->channels[$channel]->msg_on[0], $this->channels[$channel]->msg_on[1]);
	}
	
	function display_pv($text, $pv)
	{
		$this->pvs[$pv]->console->insert(null, $this->couleurs['user'], null, $text);
	}
	
	function irc_connect($server, $port)
	{
		$this->socket = socket_create(AF_INET,SOCK_STREAM,SOL_TCP);
		if ($this->socket)
			$this->display("Tentative de connexion  $server sur le port $port\r\n", 'info'); 
		socket_connect($this->socket,$server,$port); 
		socket_set_nonblock($this->socket);
		$this->send("USER PHPGTK UNKNOW UNKNOW :".$this->nick."\r\n");
		$this->send("NICK :".$this->nick."\r\n");
		$this->server = $server;
		return true;
	}
	
	function send($msg)
	{
		socket_write($this->socket, $msg, strlen($msg)); 
	}
	
	function parse_server_msg($servermsg)
	{
	fputs($this->fp, "$servermsg\r\n");	
	$dejaaffiche = false;
	
	while(gtk::events_pending()) gtk::main_iteration(); //est-ce que a sert ?
	
	$commande = explode(':', trim($servermsg), 3);
	
		switch(strtoupper($commande[0])){
			case "PING ": 
				$reponse = "PONG ".$commande[1]."\r\n";
				$this->display($reponse, 'info');
				$this->send($reponse);
				break;
				/* certains serveurs ont la forme
				* :server!truc@machin.com NOTICE AUTH : votre message
				* ce cas est prvu dans le deuxime switch
				* pour le cas "normal" qui fait
				* NOTICE AUTH : patati patata
				* c le code qui suit
				*/
			case "NOTICE AUTH ":
				$this->display($commande[1]."\r\n", 'info');
				$dejaaffiche = true;
				break;
			case "NOTICE ":
				$this->display($commande[1]."\r\n", 'info');
				$dejaaffiche = true;
				break;
			default:
				echo '';
		} // switch
		
		$action = explode(' ', trim($commande[1]));
		
		switch (strtoupper($action[1])) {
			case 'MODE':
				//if (strstr("#", $action[2]))
				if ($action[4]) //cette 2 mthode marche mais pas la premire je sais pas pk
				{
					$this->display($action[4]." a maintenant le mode ".$action[3]." sur le canal ".$action[2]."\r\n", 'server', $action[2]);
					
					$j = 0;
					$k = 0;
					$l = 0;
					$m = 0;
					$unsortedmodes = substr($action[3], 1);
					$sort = "aqohviswb";
					$modes;
					//on trie par priorits 
					while($l < strlen($sort)){
						if (strstr($unsortedmodes, $sort[$l])) {
						    $modes .= $sort[$l];
						}
						$l++;
					} // while
					
					while($k < strlen($modes))
					{
						$val = $modes[$k];
						//on parcourt tous les modes appliqu  l'utilisateur
						/* * ne marche pas
						* pour les trucs du genre
						* :user! mode #chan +vho user user user
						* */
						if (substr($action[3], 0, 1) == "+") {
						    switch($val){
								case "o" : 
									$this->change_user($action[4+$j], $action[4+$j], "@", $action[2]);
									break;
								case "h" : 
									//on vrifie qu'il est pas dj op
									if (!$this->channels[$action[2]]->users["@".$action[4+$j]])
										$this->change_user($action[4+$j], $action[4+$j], "%", $action[2]);
									break;
								case "v" : 
									//pas dj op ou halfop
									if (!$this->channels[$action[2]]->users["@".$action[4+$j]] && !$this->channels[$action[2]]->users["%".$action[4+$j]])
										$this->change_user($action[4+$j], $action[4+$j], "+", $action[2]);
									break;
								default:
									;
							} // switch
						}
						if (substr($action[3], 0, 1) == "-") {
						    switch($val){
								case "o" : 
									$this->change_user($action[4+$j], $action[4+$j], "%", $action[2]);
									break;
								case "h" : 
									if (!$this->channels[$action[2]]->users["@".$action[4+$j]])
										$this->change_user($action[4+$j], $action[4+$j], "+", $action[2]);
									break;
								case "v" : 
									if (!$this->channels[$action[2]]->users["@".$action[4+$j]] && !$this->channels[$action[2]]->users["%".$action[4+$j]])
										$this->change_user($action[4+$j], $action[4+$j], "vide", $action[2]);
									break;
								default:
									;
							} // switch
						}//if
						//echo "\r\n".substr($action[3], 1+$j, 1)."\r\n";
						$j++;
						$k++;
					}//foreach
				}
				else
				{
					$explode = explode(' ', $servermsg);
					$this->display($action[2]." a maintenant le mode ".$explode[3]."\r\n", 'server', $action[2]);
				}
				break;
			case 'NOTICE':
				$this->display($commande[2]."\r\n", 'info');
				break;
			case 'PRIVMSG':
				$user = explode('!',$action[0]);
				if (strcasecmp($action[2], $this->nick)) {//msg pour un chan "normal"
					if (strpos($commande[2], "\x01"."ACTION") === 0) {
						$commande[2] = str_replace("\x01"."ACTION", "", $commande[2]);
						$commande[2] = str_replace("\x01", "", $commande[2]);
					    $this->display($user[0]." ".$commande[2]."\r\n", 'useraction', $action[2]);
					}
					else
					{
				    	$this->display($user[0].": ".$commande[2]."\r\n", 'user', $action[2]);
					}
				}
				else //c un pv
				{
					if (!$this->pvs[$user[0]]) {
					    $this->pvs[$user[0]] = new pv($user[0], &$this);
					}
					$this->display_pv($user[0].": ".$commande[2]."\r\n", $user[0]);
				}
				break;
			case 'JOIN':
				/*
				* pour quoi re-exploder la chane du serveur ?
				* certains messages ont la forme : !user@serv.com JOIN #chan
				* et non pas !user@serv.com JOIN :#chan
				* donc l tous les cas possible sont englobs
				*/
				$user = explode('!',$action[0]);
				$explode = explode(' ', $servermsg);
				$explode[2] = str_replace(":", "", $explode[2]);
				$explode[2] = strtolower($explode[2]);
				$this->display($user[0]." a rejoint ".$explode[2]."\r\n", 'server', $explode[2]);
				if ($this->channels[$explode[2]]) $this->update_users($user[0], $explode[2]);
				//prvention des bugs pour le if
				break;
			case 'QUIT':
				/* *
				* mm remarque que pour le join
				* */
				$user = explode('!',$action[0]);
				$explode = explode(' ', $servermsg, 3);
				$explode[2] = str_replace(":", "", $explode[2]);
				$explode[2] = strtolower($explode[2]);
				$this->remove_user($user[0], null, $explode[2]);
				break;
			case 'KICK':
				$user = explode('!',$action[0]);
				$this->remove_user($action[3], $action[2]);
				if ($action[3] == $this->nick) {
				    $this->channels[$action[2]]->remove_page(null, &$this, null);
					$this->display("Vous avez t kick de ".$action[2]." par ".$user[0].". Raison : ".$commande[2]."\r\n", 'info');
				}
				else
				{
					$this->display($user[0]." a kick ".$action[3]." de ".$action[2].". Raison : ".$commande[2]."\r\n", 'server', $action[2]);
				}
				break;
			case 'PART':
				$user = explode('!',$action[0]);
				$explode = explode(' ', $servermsg);
				$explode[2] = str_replace(":", "", $explode[2]);
				$explode[2] = strtolower($explode[2]);
				
				$this->remove_user($user[0], $explode[2]);
				$this->display($user[0]." a quitt ".$explode[2]."\r\n", 'server', $explode[2]);
				break;
			case 'NICK':
				$user = explode('!',$action[0]);
				$this->change_user($user[0], $commande[2]);
				break;
			case '332': //topic
				$user = explode('!',$action[0]);
				$this->display("Topic de ".$action[3]." : ".$commande[2]."\r\n", 'server', $action[3]);
				break;
			case '353': //liste des utilisateurs
				$user = explode('!',$action[0]);
				$this->display("Utilisateurs sur ".$action[4]." : ".$commande[2]."\r\n", 'server', $action[4]);
				$cle = strtolower($action[4]);
				if ($this->channels[$cle]) $this->update_users($commande[2], $cle);
				//longtemps eu bcp de bugs  ce niveau, le if en vite
				break;
			case '433' : //nickname already in use
				$this->display("Erreur 433 : pseudo dj utilis\r\n", 'info');
				srand((float) microtime()*1000000);
				$j = 0;
				$str = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
				$newnick = "phpgtk_";
				while($j <= 8) {
					$char = rand(0, strlen($str));
					$newnick .= $str[$char];
					$j++;
				} // while
				$this->nick = $newnick;
				$this->send("NICK :$newnick\r\n");
				break;
			case '432' : //pseudo ircop lol
				$this->display("Erreur 432 : pseudo IRCop\r\n", 'info');
				srand((float) microtime()*1000000);
				$j = 0;
				$str = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
				$newnick = "phpgtk_";
				while($j <= 8) {
					$char = rand(0, strlen($str));
					$newnick .= $str[$char];
					$j++;
				} // while
				$this->nick = $newnick;
				$this->send("NICK :$newnick\r\n");
				break;
			case '333' ://topic set by ... x seconds ago
				$this->display("Topic de ".$action[3]." mis par ".$action[4]." il y a ".$action[5]." secondes\r\n", 'info', $action[3]);
				break;
			case '005' ://les paramtres dont nicklen
				if ($debut = strpos($servermsg, "NICKLEN")) {
				    $nicklen = trim(substr($servermsg, $debut+8, 2));
					$this->nick = substr($this->nick, 0, $nicklen);
				}
				$this->display($servermsg."\r\n", 'info');
				break;
			case 'TOPIC' :
				$user = explode('!',$action[0]);
				$this->display($user[0]." a chang le topic de ".$action[2]." pour ".$commande[2]."\r\n", 'server', $action[2]);
				break;
			case '001' :
				/* *hmm
				* juste que quand on reoit le code 001 a veut dire
				* qu'on est logg et tout donc je peux faire pter
				* le performbuffer
				* */
				if ($this->performbuffer) {
					foreach ($this->performbuffer as $cle => $val)
						{
							$this->usercommand->set_text($val);
					    	$this->parse_user_msg();
							$this->performbuffer[$cle] = null;
						}
				}
				$this->display($servermsg."\r\n", 'info');
				break;
			default:
				if (!$dejaaffiche)
				    $this->display($servermsg."\r\n", 'info');
		} // 
	}
	
	function update_irc()
	{
		if ($datairc = @socket_read($this->socket, 16384)) {
		    $stack = explode("\r\n", trim($datairc));
			$stack[0] = $this->currentmsg.$stack[0];
			$this->currentmsg = null;
			foreach ($stack as $cle => $servermsg)
			{
				$this->debugconsole->insert(null, $this->colorserver, null, $servermsg."\r\n");
				$this->parse_server_msg($servermsg);
				/* *
				 * 
				 * 				if (strlen($datairc) >= 20480)
				 * 			    	$this->currentmsg = $servermsg;
				 * 				else
				 * 			    	$this->currentmsg = null;
				 * 
				 * code  l'efficacit douteuse... de tte faon j'ai augment
				 * la quantit de donnes  lire du socket
				 * */
			}
		}
		$datairc = null;
		return true;
	}
	
	function refresh()
	{
		$this->channels[$this->currentchannel]->console->thaw();
		while (gtk::events_pending()) gtk::main_iteration();
		return true;
	}
	
	function quit()
	{
		$this->send("QUIT :http://www.central-game.com/irc%20chatter.rar ze client irc crit en phpgtk entirement fonctionnel");
		echo "socket ferme\r\n";
		socket_close($this->socket);
		fclose($this->fp);
	}
	
	function parse_user_msg()
	{
		$command = $this->usercommand->get_chars(0, -1);
		$this->usercommand->set_text("");
		$action = explode(' ', $command, 3);
		switch(strtolower($action[0])){//allez hop insensible  la case ;)
			case '/join':
				$this->new_notebook_page($action[1]);
				$newcommand = "JOIN ".$action[1];
				break;
			case '/kick' :
				$newcommand = "KICK ".$this->currentchannel." ".$action[1]." :".$action[2];
				break;
			case '/nick':
				$newcommand = "NICK :".$action[1];
				$this->nick = $action[1];
				break;
			case '/raw':
				$newcommand = $action[1]." ".$action[2];
				break;
			case '/msg':
				$newcommand = "PRIVMSG ".$action[1]." :".$action[2];
				break;
			case '/debug':
				print_r($this->channels);
				echo $this->currentchannel."\r\n";
				break;
			case '/me':
				$action2 = explode(' ', $command, 2);
				$newcommand = "PRIVMSG ".$this->currentchannel." :"."\x01"."ACTION ".$action2[1]."\x01";
				$this->display($this->nick." ".$action2[1]."\r\n", 'useraction', $this->currentchannel);
				break;
			default:
				$this->display($this->nick.": ".$command."\r\n", 'user', $this->currentchannel);
				$newcommand = "PRIVMSG ".$this->currentchannel." :".$command;
		} // switch
		echo $newcommand."\r\n";
		if ($newcommand) {
		    $this->send($newcommand."\r\n");
		}
	}
	
	function change_user($user, $newnick, $prefix2 = false, $canal = null)
	{
	$user = trim($user);
	$newnick = trim($newnick);
	//marche pas pour un -hov par exemple faut trier dans l'ordre croissant...
		foreach ($this->channels as $cle => $channel)
			{
				if ($this->channels[$cle]->users[$user] || $this->channels[$cle]->users["+".$user] || $this->channels[$cle]->users["%".$user] || $this->channels[$cle]->users["@".$user]) {
					$this->channels[$cle]->userlist->clear();
					
					if ($this->channels[$cle]->users[$user]) {
					    $this->channels[$cle]->users[$user] = 0;
						$prefix = null;
					}
					
					if ($this->channels[$cle]->users["+".$user]) {
					    $this->channels[$cle]->users["+".$user] = 0;
						$prefix = "+";
					}
					
					if ($this->channels[$cle]->users["@".$user]) {
					    $this->channels[$cle]->users["@".$user] = 0;
						$prefix = "@";
					}
					
					if ($this->channels[$cle]->users["%".$user]) {
					    $this->channels[$cle]->users["%".$user] = 0;
						$prefix = "%";
					}
					//tous ces blocs if pour prserver le prfix qui est conserv dans la liste des nicks
					
					if ($prefix2 && strtolower($cle) == strtolower($canal))
						$prefix = $prefix2;
					if ($prefix2 == "vide") //on met vide au moment du mode -v uniquement
						$prefix = null;
					
					//pour les nicks @op ou +voice etc..
					$this->channels[$cle]->i++;
				    $this->channels[$cle]->users[$prefix.$newnick] = $this->channels[$cle]->i;		
					$this->channels[$cle]->users = array_flip($this->channels[$cle]->users);
					natcasesort($this->channels[$cle]->users);
					$this->channels[$cle]->users = array_flip($this->channels[$cle]->users);
					
					//on redessine la liste
					foreach ($this->channels[$cle]->users as $cle2 => $val)
					{
						if ($val)
						{
							switch($cle2[0]){
								case '@': 
									$tempcolor = $this->couleurs['op'];
									$cle2 = substr($cle2, 1);
									break;
								case '%': 
									$tempcolor = $this->couleurs['halfop'];
									$cle2 = substr($cle2, 1);
									break;
								case '+': 
									$tempcolor = $this->couleurs['voice'];
									$cle2 = substr($cle2, 1);
									break;
								default:
									$tempcolor = $this->couleurs['default'];
							} // switch
							$this->channels[$cle]->userlist->Append(array($cle2)); 
							$cle2 = trim($cle2);
							$this->channels[$cle]->userlist->set_foreground(($this->channels[$cle]->userlist->rows - 1), $tempcolor);
						}
					}
					
					if (!$prefix2) //c'est pas un changement de mode
					    $this->display($user." est maintenant ".$newnick."\r\n", "server", $cle);
					
				}
			}
	}
	
	function remove_user($user, $chan=null, $raison=null)
	{
	$chan = strtolower($chan);
	
		if ($chan) {
		    $this->channels[$chan]->users[$user] = 0;
			$this->channels[$chan]->userlist->clear();
			$this->channels[$chan]->users = array_flip($this->channels[$chan]->users);
			natcasesort($this->channels[$chan]->users);
			$this->channels[$chan]->users = array_flip($this->channels[$chan]->users);
			foreach ($this->channels[$chan]->users as $cle => $val)
			{
				if ($val) 
				{
					switch($cle[0]){
						case '@': 
							$tempcolor = $this->couleurs['op'];
							$cle = substr($cle, 1);
							break;
						case '%': 
							$tempcolor = $this->couleurs['halfop'];
							$cle = substr($cle, 1);
							break;
						case '+': 
							$tempcolor = $this->couleurs['voice'];
							$cle = substr($cle, 1);
							break;
						default:
							$tempcolor = $this->couleurs['default'];
					} // switch
					$this->channels[$chan]->userlist->Append(array($cle)); 
					$cle = trim($cle);
					$this->channels[$chan]->userlist->set_foreground(($this->channels[$chan]->userlist->rows - 1), $tempcolor);
				}
			} 
		}
		else
		{
			foreach ($this->channels as $cle => $channel)
			{
				if ($this->channels[$cle]->users[$user]) {
					$this->channels[$cle]->userlist->clear();
				    $this->channels[$cle]->users[$user] = 0;
					$this->channels[$cle]->users = array_flip($this->channels[$cle]->users);
					natcasesort($this->channels[$cle]->users);
					$this->channels[$cle]->users = array_flip($this->channels[$cle]->users);
					
					foreach ($this->channels[$cle]->users as $cle2 => $val)
					{
						if ($val)
						{
							switch($cle2[0]){
								case '@': 
									$tempcolor = $this->couleurs['op'];
									$cle2 = substr($cle2, 1);
									break;
								case '%': 
									$tempcolor = $this->couleurs['halfop'];
									$cle2 = substr($cle2, 1);
									break;
								case '+': 
									$tempcolor = $this->couleurs['voice'];
									$cle2 = substr($cle2, 1);
									break;
								default:
									$tempcolor = $this->couleurs['default'];
							} // switch
							$this->channels[$cle]->userlist->Append(array($cle2)); 
							$cle2 = trim($cle2);
							$this->channels[$cle]->userlist->set_foreground(($this->channels[$cle]->userlist->rows - 1), $tempcolor);
						}
					}
				$this->display($user." a t dconnect(e) du serveur. Raison : ".$raison."\r\n", 'server', $cle);
				}
			}
		}
	}
	
	function update_users($list, $channel2)
	{
		//prparation
		$channel2 = strtolower($channel2);
		$this->channels[$channel2]->userlist->clear();
		$userlist = explode(' ', trim($list));
		
		foreach ($userlist as $cle => $val)
		{
			$this->channels[$channel2]->users[$val] = $this->channels[$channel2]->i;
			$this->channels[$channel2]->i++;
		}
		
		//bloc tri
		$this->channels[$channel2]->users = array_flip($this->channels[$channel2]->users);
		natcasesort($this->channels[$channel2]->users);
		$this->channels[$channel2]->users = array_flip($this->channels[$channel2]->users);
		
		foreach ($this->channels[$channel2]->users as $cle => $val)
		{
			//echo $this->channels[$channel2]->userlist->rows;
			switch($cle[0]){
				case '@': 
					$tempcolor = $this->couleurs['op'];
					$cle = substr($cle, 1);
					break;
				case '%': 
					$tempcolor = $this->couleurs['halfop'];
					$cle = substr($cle, 1);
					break;
				case '+': 
					$tempcolor = $this->couleurs['voice'];
					$cle = substr($cle, 1);
					break;
				default:
					$tempcolor = $this->couleurs['default'];
			} // switch
			$this->channels[$channel2]->userlist->Append(array($cle)); 
			$cle = trim($cle);
			$this->channels[$channel2]->userlist->set_foreground(($this->channels[$channel2]->userlist->rows - 1), $tempcolor);
		}
		
		$this->channels[$channel2]->userlist->thaw();
		$this->channels[$channel2]->userlist->columns_autosize();
	}
	
	function new_notebook_page($titre)
	{
		$titre = strtolower($titre);
		$this->channels[$titre] = new channel($titre, &$this);
		$this->currentchannel = $titre;
	}
	
	function page_switch(&$notebook, $page, $pagenum)
	{
		$tab_label = $this->notebook->get_tab_label($this->notebook->get_nth_page($pagenum));
		$children = $tab_label->children();
		$label = $children[1];
		$msg_on = gdk::pixmap_create_from_xpm($this->window->window, null, '../irc_chatter/msg_on.xpm');
		$children[0]->set($msg_on[0], $msg_on[1]);
		$this->currentchannel = $label->get();
		
			$tab_label = $this->notebook->get_tab_label($this->notebook->get_nth_page($this->notebook->get_current_page()));
			if ($tab_label) {
			    $children = $tab_label->children();
				$msg_off = gdk::pixmap_create_from_xpm($this->window->window, null, '../irc_chatter/msg_off.xpm');
				$children[0]->set($msg_off[0], $msg_off[1]);
			}
		
	}
	
	function new_pv($distantuser)
	{
		$this->pvs[$distantuser] = new pv($distantuser, &$this);
	}
	
	
}

class channel
{
var $name;
var $console;
var $userlist;
var $users = array();
var $i;
var $msg_on;
var $msg_off;
var $pixwid;
var $lastclickedname;
var $parentclass;

	function channel($titre, &$parentclass)
	{
		$this->i = 1;
		$this->parentclass = &$parentclass;
		
		$titre = strtolower($titre);
		$child = &new GtkFrame($titre);
		$child->set_border_width(5);
		
		$box3 = &new GtkHBox();
		$this->console = &new GtkText;
		$scrollbar = &new GtkVScrollbar($this->console->vadj);
		$this->console -> set_editable(false);
		$this->console -> set_word_wrap(true);
		$box3->pack_start($this->console, true, true, 5);
		$box3->pack_end($scrollbar, false);
		
		if ($titre != "status") {
			$hbox = &new GtkVBox();
			$this->userlist = &new GtkCList(1, array("utilisateurs"));
			$this->userlist->columns_autosize();
			$scrolled_win = &new gtkscrolledwindow();
			$scrolled_win->set_policy(gtk_policy_automatic, gtk_policy_automatic);
			$scrolled_win->add($this->userlist);
			$hbox->pack_start($scrolled_win);
			$button = &new GtkButton(":: Fermer le channel ::");
			$hbox->pack_end($button, false, false, 5);
			$box3->pack_start($hbox, false, true, 5);
			$this->userlist->connect_after( "select-row", array(&$this, "list_item_clicked"), &$this->parentclass);
		}
		
		$child->add($box3);
		
		$label_box = &new GtkHBox(false, 0);
		$this->msg_on = gdk::pixmap_create_from_xpm($parentclass->window->window, null, '../irc_chatter/msg_on.xpm');
		$this->msg_off = gdk::pixmap_create_from_xpm($parentclass->window->window, null, '../irc_chatter/msg_off.xpm');
		$this->pixwid = &new GtkPixmap($this->msg_off[0], $this->msg_off[1]);
		$label_box->pack_start($this->pixwid, false, true, 0);
		$this->pixwid->set_padding(3, 1);
		$label = &new GtkLabel($titre);
		$label_box->pack_start($label, false, true, 0);
		$label_box->show_all();
		
		$this->parentclass->notebook->append_page($child, $label_box);
		$page = $this->parentclass->notebook->page_num($child);
		$child->show_all();
		$this->parentclass->notebook->set_page($this->parentclass->notebook->page_num($child));
		$this->name = $titre;
		
		if ($titre != "status") {
		    $button->connect("clicked", array(&$this, "remove_page"), &$this->parentclass, $this->name);
		}
	}
	
	function list_item_clicked()
	{
		$selection = $this->userlist->selection; 
		$row = $this->userlist->Get_Row_Data($selection[0]);
		$clickedname = $this->userlist->get_text($selection[0], 0);
		if ($this->lastclickedname == $clickedname) {
			$this->parentclass->new_pv($clickedname);
		}
		$this->lastclickedname = $clickedname;
	}
	
	function remove_page($button, &$parentclass, $name)
	{
		$parentclass->send("PART :".$parentclass->currentchannel."\r\n");
		$parentclass->notebook->remove_page($parentclass->notebook->get_current_page());
	}
	
}

class pv
{
var $distantuser;
var $console;
var $entry;
var $parentclass;
var $pvwindow;

	function pv($distantuser, &$parentclass)
	{
		$this->distantuser = $distantuser;
		$this->parentclass = &$parentclass;
			
		$this->pvwindow = &new GtkWindow;
		$this->pvwindow->set_usize('400', '300');
		$this->pvwindow->set_title("PV : $distantuser");
		$this->pvwindow->connect("destroy", array(&$this, "destroy_pv"));
		
		$dgbox = &new GtkVBox(false, 10);
		$dgbox->set_border_width(10);
		$this->pvwindow->add($dgbox);
		
		$dhbox = &new GtkHBox;
		$this->console = &new GtkText;
		$dscrollbar = &new GtkVScrollbar($this->console->vadj);
		$this->console->set_editable(false);
		$this->console->set_word_wrap(true);
		$dhbox->pack_start($this->console, true, true, 5);
		$dhbox->pack_end($dscrollbar, false);
		$dgbox->pack_start($dhbox);
		
		$this->entry = &new GtkEntry();
		$dgbox->pack_start($this->entry, false, false);
		
		$this->pvwindow->show_all();
		
		$this->entry->connect_after("activate", array(&$this, "parse_pv_command"), $this->distantuser);
	}
	
	
	function parse_pv_command()
	{
		$msg = $this->entry->get_text();
		$distantuser = $this->distantuser;
		$this->parentclass->send("PRIVMSG $distantuser :$msg\r\n");
		$this->parentclass->display_pv($this->parentclass->nick.": ".$msg."\r\n", $distantuser);
	}
	
	function destroy_pv()
	{
		$this->pvwindow->destroy();
		$this->parentclass->pvs[$this->distantuser] = null;
	}
}

?>