<?php

/**
 * 
 *
 * @version $Id: php.xml,v 1.0 2003-01-02 20:23:56+01 administrateur Exp administrateur $
 * @copyright 2002 ARECOM International
 **/
 
function destroy_window($window, $event)
{
	$window->destroy();
	return true;
}

function destroy_window_from_widget($widget)
{
	$window = $widget->get_toplevel();
	$window->destroy();
}
 
include ('conf.txt');
include('fonctions.php');
include('classes.php');

if (!extension_loaded('gtk'))
        dl( 'php_gtk.' . (strstr( PHP_OS, 'WIN') ? 'dll' : 'so'));	
		
if (isset($strStyle)) {
	GTK::rc_parse( GTK::rc_get_theme_dir() . "/" . $strStyle . "/gtk/gtkrc");
}

set_time_limit(0);

function create_server($button, &$serverw, &$portw, &$x)
{
global $serverlist;

	$x->destroy();
	$server = $serverw->get_text();
	$port = $portw->get_text();
	
	$fp = fopen("servers.txt", "r");
	$servers = unserialize(fread($fp, filesize("servers.txt")));
	fclose($fp);
	
	$servers[$server] = $port;
	unlink("servers.txt");
	$fp = fopen("servers.txt", "w+");
	fputs($fp, serialize($servers));
	fclose($fp);
	
	$i = 0;
	$serverlist->clear();
	foreach ($servers as $cle => $val)
	{
		$serverlist->Append(array($cle));
		$serverlist->Set_Row_Data($i, $cle.':'.$val); 
		$i++;
	}
	$serverlist->select_row(0, 0);
	
	return true;
}

function remove_server()
{
	global $serverlist;
	$selection = $serverlist->selection;
	$row = $serverlist->Get_Row_Data($selection[0]); 
	list($server, $port) = explode(":", $row);
	
	$fp = fopen("servers.txt", "r");
	$servers = unserialize(fread($fp, filesize("servers.txt")));
	fclose($fp);
	
	foreach ($servers as $cle => $val)
	{
		if ($cle != $server) {
		    $newservers[$cle] = $val;
		}
	}
	
	unlink("servers.txt");
	$fp = fopen("servers.txt", "w+");
	fputs($fp, serialize($newservers));
	fclose($fp);
	
	print_r($newservers);
	
	$i = 0;
	$serverlist->clear();
	foreach ($newservers as $cle => $val)
	{
		$serverlist->Append(array($cle));
		$serverlist->Set_Row_Data($i, $cle.':'.$val); 
		$i++;
	}
	$serverlist->select_row(0, 0);
}

function new_server_window($widget)
{
	$x = &new GtkWindow;
	$x->set_title("Nouveau serveur");
	$x->set_usize('150', '100');
	$x->connect("destroy", "destroy_window", null);
	$vbox = &new GtkVBox();
	$vbox->set_border_width(5);
	$x->add($vbox);
	
	$server = &new GtkEntry();
	$server->set_text("Serveur");
	$vbox->pack_start($server, false, false, 5);
	
	$port = &new GtkEntry();
	$port->set_text("Port");
	$vbox->pack_start($port, false, false, 5);
	
	$valid = &new GtkButton("Valider !");
	$vbox->pack_start($valid, false, false, 5);
	$valid->connect("clicked", "create_server", &$server, &$port, &$x);
	
	$x->show_all();
}

function connect_to_server($widget)
{
	global $w;
	global $serverlist;
	global $nick;
	$usernick = $nick->get_text();
	$selection = $serverlist->selection;
	$row = $serverlist->Get_Row_Data($selection[0]); 
	list($server, $port) = explode(":", $row);
	echo "tentative de connection a $server sur le port $port\r\n";
	$w->hide();
	$ircserver = new irc_control($server, $port, $usernick);
}

//--------------------------------------------------------
$w = &new GtkWindow();
$w->set_usize('280', '240');
$w->set_title("Serveurs");
$w->connect("destroy", "killwindow", null);

$hbox = &new GtkHBox();
$hbox->set_border_width(5);
$w->add($hbox);
$serverlist = &new GtkCList(1, array("::  serveurs  ::"));
$serverlist->set_selection_mode(GTK_SELECTION_SINGLE);

$fp = fopen("servers.txt", "r");
$txtservers = fread($fp, filesize("servers.txt"));
fclose($fp);

$servers = unserialize($txtservers);
$i = 0;
foreach ($servers as $cle => $val)
{
	$serverlist->Append(array($cle));
	$serverlist->Set_Row_Data($i, $cle.':'.$val); 
	$i++;
}
$serverlist->select_row(0, 0);
$hbox->pack_start($serverlist, true, true, 5);

$vbox = &new gtkVBox();
$button1 = &new GtkButton("Nouveau serveur");
$button2 = &new GtkButton("Connecter");
$button3 = &new GtkButton("Supprimer le serveur");
$nick = &new gtkEntry();
$nick->set_text("votre nick");
$vbox->pack_start($button1, false, false, 5);
$vbox->pack_start($button3, false, false, 5);
$vbox->pack_start($nick, false, false, 5);
$vbox->pack_start($button2, false, false, 5);
$button1->connect('clicked', "new_server_window");
$button2->connect('clicked', "connect_to_server");
$button3->connect('clicked', "remove_server");
$hbox->pack_start($vbox, false, false);

$w->show_all();
//--------------------------------------------------------

gtk::main();  
?>